using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Windows.Forms;
using System.Security.Cryptography;
using System.Text.RegularExpressions;
using System.Web;
using System.Diagnostics;
using System.Collections.Specialized;
using System.Xml.Serialization;
using CommonLib;
using convert.Properties;

namespace convert
{
    class Program
    {
        static SHA512Managed sha = new SHA512Managed();
        static Encoding sjis = Encoding.GetEncoding(932);
        static Encoding enc = Encoding.UTF8;
        static Regex logregex = new Regex(@"frame=(?<frame>[ \d]{5}) fps=(?<fps>[ \d]{3}) q=(?<q>\d\d\.\d) size=(?<size>[ \d]{8})kB time=(?<time>\d+\.\d) bitrate=(?<bitrate>[ \d]{4}\.\d)kbits/s");
        static Regex logrege2 = new Regex(@"size=(?<size>[ \d]{8})kB time=(?<time>\d+\.\d) bitrate=(?<bitrate>[ \d]{5}\.\d)kbits/s");

        static void Main()
        {
            bool bIsRuned = false;

            //GETϐ擾
            NameValueCollection get = HttpUtility.ParseQueryString(
                Environment.GetEnvironmentVariable("QUERY_STRING"), sjis);

            //Ώۃt@C擾
            string path = null;
            if (get.Get("path") != null)
                path = decode(get["path"]);
            else
                DieError400();

            Console.WriteLine("Content-Type:text/html;charset=shift_jis\n");
            Console.WriteLine(Resources.Header, Path.GetFileName(path), get["path"], DateTime.Now.Ticks);

            string hash = BitConverter.ToString(sha.ComputeHash(sjis.GetBytes(path))).Replace("-", "");
            string name = Path.GetFileName(path);
            string file = Path.Combine(PathConf.cdir, hash);
            string ccpy = Path.Combine(PathConf.tdir, "tmp.log");
            string odir = Path.Combine(PathConf.cdir, hash + ".converted");

            Settings def = Settings.Default;

            //t@CRs[
            if (File.Exists(file) == false)
            {
                File.Copy(path, file);
            }

            //ϊvZX̋NƂݒ̕ۑ
            if (get.Get("btn") != null)
            {
                int aandv = int.Parse(get["aandv"]);
                uint ab = uint.Parse(get["ab"]);
                uint vb = uint.Parse(get["vb"]);
                uint fps = uint.Parse(get["fps"]);

                if (get["btn"] == "ϊ(6)" && !IsRunning())
                {
                    string odi2 = Path.Combine(odir, String.Format("{0}-{1}-{2}", vb, ab, fps));

                    if (Directory.Exists(odi2) == false)
                        Directory.CreateDirectory(odi2);

                    ConvParam cp = new ConvParam((int)vb, (int)ab, (int)fps, file, odi2, name);
                    File.Delete(PathConf.param);
                    new XmlSerializer(typeof(ConvParam)).Serialize(File.OpenWrite(PathConf.param), cp);
                    Process.Start(Path.Combine(PathConf.adir, "convertbg"));
                    bIsRuned = true;
                }
                else if (get["btn"] == "ۑ(4)")
                {
                    def.ab = ab;
                    def.vb = vb;
                    def.fps = fps;
                    def.aandv = aandv;
                }
                else if (get["btn"] == "~(#)")
                {
                    Process.Start(Path.Combine(PathConf.adir, "bin/Stop.bat"));
                }
            }

            //ϊ󋵂̕\
            Console.WriteLine("<hr /><a href='#status' id='#status' accesskey='1'>#</a><h3>ϊ</h3>");
            if (IsRunning())
            {
                File.Copy(PathConf.commonlog, ccpy, true);
                string[] lines = File.ReadAllLines(ccpy);
                string last = lines[lines.Length - 1];
                Match m = logregex.Match(last);
                Match m2 = logrege2.Match(last);
                if (m.Success)
                {
                    lines = File.ReadAllLines(PathConf.clengthlog);
                    TimeSpan tstotal = TimeSpan.Parse(lines[0]);
                    TimeSpan tsfinished = lines.Length == 2 ?
                        TimeSpan.Parse(lines[1]) : new TimeSpan();
                    TimeSpan tscurrent = new TimeSpan((long)(double.Parse(m.Groups["time"].Value)) * 10000000);
                    double parcent = (double)(tscurrent.Ticks + tsfinished.Ticks) / (double)tstotal.Ticks;
                    string size = m.Groups["size"].Value;
                    Console.WriteLine("<p>{4}</p><p>{0:P}[{5}]<br />{1}/{2}({3}kb)</p>",
                        parcent, tscurrent + tsfinished, tstotal, size, name, CreateBar(parcent));
                }
                else if (m2.Success)
                {
                    lines = File.ReadAllLines(PathConf.clengthlog);
                    TimeSpan tstotal = TimeSpan.Parse(lines[0]);
                    TimeSpan tsfinished = lines.Length == 2 ?
                        TimeSpan.Parse(lines[1]) : new TimeSpan();
                    TimeSpan tscurrent = new TimeSpan((long)(double.Parse(m.Groups["time"].Value)) * 10000000);
                    double parcent = (double)(tscurrent.Ticks + tsfinished.Ticks) / (double)tstotal.Ticks;
                    string size = m.Groups["size"].Value;
                    Console.WriteLine("<p>{4}</p><p>{0:P}<br />{1}/{2}({3}kb)</p>",
                        parcent, tscurrent + tsfinished, tstotal, size, name);
                }
                else
                {
                    Console.WriteLine("<p>͂łȂ̂ŎŌĂB<br />{0}</p>", last);
                }

                Console.WriteLine(Resources.CancelForm,get[0]);
            }
            else if (bIsRuned)
            {
                Console.WriteLine("<p>ϊJn܂B<br />{0}</p>", name);
            }
            else
            {
                Console.WriteLine("<p>ݕϊ̧ق͂܂B</p>");
            }

            //ϊς݃t@C̕\
            Console.WriteLine("<hr /><a href='#conved' id='#conved' accesskey='2'>#</a><h3>ϊς̧</h3>");
            if (Directory.Exists(odir))
            {
                string[] dirs = Directory.GetDirectories(odir);
                foreach (string dir in dirs)
                {
                    Console.WriteLine("<h4>{0}</h4>", Path.GetFileName(dir));
                    string[] files = Directory.GetFiles(dir);
                    foreach (string _3g2 in files)
                    {
                        Console.WriteLine(Resources.Download,
                            String.Format("{0}/{1}.converted/{2}/{3}", PathConf.curl, hash,
                            Path.GetFileName(dir), Path.GetFileName(_3g2)),
                            Path.GetFileNameWithoutExtension(_3g2), new FileInfo(_3g2).Length, name);
                    }
                }
            }
            else
            {
                Console.WriteLine("<p>̓͂܂ϊĂ܂B</p>");
            }

            //ϊtH[̕\
            Console.WriteLine("<hr /><a href='#convform' id='#convform' accesskey='3'>#</a><h3>ϊݒ</h3>");
            Console.WriteLine(Resources.ConvertForm,
                get["path"],
                (def.aandv == 0).ToString(),
                (def.aandv == 1).ToString(),
                (def.aandv == 2).ToString(),
                def.ab.ToString(),
                def.vb.ToString(),
                def.fps.ToString(),
                !IsRunning());

            Console.WriteLine(Resources.Footer);
        }

        private static bool IsRunning()
        {
            return File.Exists(PathConf.mutex);
        }

        private static void DieError400()
        {
            Console.WriteLine("Content-Type:text/html;charset=shift_jis\n");
            Console.WriteLine("<html><head><title>Error 400</title></head><body><p>t@Cw肳ĂȂ݂łB</p></body></html>");
        }

        static string decode(string val)
        {
            return HttpUtility.UrlDecode(("-" + val).Replace("-", "%"), enc);
        }

        static string CreateBar(double parcent)
        {
            string bar = "";
            int lim = (int)(parcent * 20);
            for (int i = 0; i < 20; i++)
            {
                if (i <= lim)
                    bar += "#";
                else
                    bar += "&nbsp;";
            }
            return bar;
        }
    }
}
